import React, { useState } from 'react';
import AtomSwitch from '@s-ui/react-atom-switch';
export function TcfSecondLayerUserDecision(_ref) {
  var onConsentChange = _ref.onConsentChange,
      baseClass = _ref.baseClass,
      info = _ref.info,
      consentValue = _ref.consentValue,
      _ref$hasConsent = _ref.hasConsent,
      hasConsent = _ref$hasConsent === void 0 ? true : _ref$hasConsent,
      vendorList = _ref.vendorList,
      expandedContent = _ref.expandedContent,
      i18n = _ref.i18n;

  var _useState = useState(false),
      expanded = _useState[0],
      setExpanded = _useState[1];

  var handleItemClick = function handleItemClick() {
    setExpanded(!expanded);
  };

  var Switchs = /*#__PURE__*/React.memo(function () {
    return hasConsent && /*#__PURE__*/React.createElement(AtomSwitch, {
      type: "single",
      name: "groupItem",
      value: consentValue,
      label: i18n.CONSENT_COPY,
      onToggle: function onToggle() {
        return onConsentChange(consentValue);
      }
    });
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "" + baseClass
  }, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-accordion",
    onClick: handleItemClick
  }, /*#__PURE__*/React.createElement("svg", {
    className: expanded ? baseClass + "-icon " + baseClass + "-icon--open" : baseClass + "-icon",
    width: "16",
    height: "16",
    viewBox: "0 0 16 16"
  }, /*#__PURE__*/React.createElement("path", {
    d: "M8 10.296l5.75-6.517c.122-.138.333-.15.47-.029.139.122.152.333.03.47L8.445 10.8c-.113.127-.275.2-.445.2-.17 0-.332-.073-.445-.2L1.75 4.22c-.122-.137-.109-.348.03-.47.137-.122.348-.109.47.03L8 10.295z"
  })), /*#__PURE__*/React.createElement("span", null, info.name)), hasConsent ? /*#__PURE__*/React.createElement(Switchs, null) : null), expanded && /*#__PURE__*/React.createElement("div", {
    className: baseClass + "Description"
  }, expandedContent({
    info: info,
    baseClass: baseClass
  })));
}
TcfSecondLayerUserDecision.defaultProps = {
  hasConsent: true
};
export default /*#__PURE__*/React.memo(TcfSecondLayerUserDecision);