import _regeneratorRuntime from "@babel/runtime/regenerator";
import _extends from "@babel/runtime/helpers/esm/extends";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import React, { useState, useEffect } from 'react';
import SuiModal from '@s-ui/react-molecule-modal';
import Button from '@s-ui/react-atom-button';
import IconClose from './components/iconClose';
import TcfSecondLayerDecisionGroup from './components/tcf-secondLayer-decision-group';
import TcfSecondLayerVendorExpandedContent from './components/tcf-secondLayer-vendor-expandedContent';
import { I18N, ADEVINTA_COLLECTED_CONSENTS } from './settings';
import TcfSecondLayerLegalExpandedContent from './components/tcf-secondLayer-legal-expandedContent';
var CLASS = 'sui-TcfSecondLayer';
var groupBaseClass = CLASS + "-group";
export default function TcfSecondLayer(_ref) {
  var isMobile = _ref.isMobile,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'es' : _ref$lang,
      logo = _ref.logo,
      loadUserConsent = _ref.loadUserConsent,
      saveUserConsent = _ref.saveUserConsent,
      getVendorList = _ref.getVendorList,
      onGoBack = _ref.onGoBack,
      onVendorsClick = _ref.onVendorsClick,
      isVendorLayer = _ref.isVendorLayer;

  var _useState = useState(null),
      state = _useState[0],
      setState = _useState[1];

  var _useState2 = useState(true),
      modalOpen = _useState2[0],
      setModalOpen = _useState2[1];

  var _useState3 = useState(null),
      vendorListState = _useState3[0],
      setVendorListState = _useState3[1];

  var i18n = I18N[lang];
  useEffect(function () {
    var getVendorListAndConsent = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var _yield$getVendorList, purposes, specialPurposes, features, specialFeatures, vendors, userConsent;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return getVendorList({
                  language: lang
                });

              case 2:
                _yield$getVendorList = _context.sent;
                purposes = _yield$getVendorList.purposes;
                specialPurposes = _yield$getVendorList.specialPurposes;
                features = _yield$getVendorList.features;
                specialFeatures = _yield$getVendorList.specialFeatures;
                vendors = _yield$getVendorList.vendors;
                setVendorListState({
                  purposes: purposes,
                  specialPurposes: specialPurposes,
                  features: features,
                  specialFeatures: specialFeatures,
                  vendors: vendors
                });
                _context.next = 11;
                return loadUserConsent();

              case 11:
                userConsent = _context.sent;

                if (userConsent.isNew) {
                  userConsent.vendor.consents = format({
                    reference: vendors,
                    object: {},
                    value: true
                  });
                  userConsent.vendor.legitimateInterests = _extends({}, userConsent.vendor.consents);
                  userConsent.purpose.consents = {};
                  userConsent.purpose.legitimateInterests = {};
                  ADEVINTA_COLLECTED_CONSENTS.purposes.forEach(function (key) {
                    userConsent.purpose.consents[key] = true;
                    userConsent.purpose.legitimateInterests[key] = true;
                  });
                  userConsent.specialFeatures = {};
                  ADEVINTA_COLLECTED_CONSENTS.specialFeatures.forEach(function (key) {
                    return userConsent.specialFeatures[key] = true;
                  });
                }

                setState({
                  vendors: userConsent.vendor,
                  purposes: userConsent.purpose,
                  specialFeatures: userConsent.specialFeatures
                });

              case 14:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function getVendorListAndConsent() {
        return _ref2.apply(this, arguments);
      };
    }();

    getVendorListAndConsent();
  }, [getVendorList, loadUserConsent, lang]);

  var handleCloseModal = function handleCloseModal() {
    setModalOpen(false);
  };

  var format = function format(_ref3) {
    var reference = _ref3.reference,
        object = _ref3.object,
        _ref3$value = _ref3.value,
        value = _ref3$value === void 0 ? false : _ref3$value;
    Object.keys(reference).forEach(function (key) {
      if (!object[key]) {
        object[key] = value;
      }
    });
    return object;
  };

  var formatConsentObject = function formatConsentObject(_ref4) {
    var _ref4$vendor = _ref4.vendor,
        vendor = _ref4$vendor === void 0 ? {} : _ref4$vendor,
        _ref4$purpose = _ref4.purpose,
        purpose = _ref4$purpose === void 0 ? {} : _ref4$purpose,
        _ref4$specialFeatures = _ref4.specialFeatures,
        specialFeatures = _ref4$specialFeatures === void 0 ? {} : _ref4$specialFeatures;
    vendor.consents = format({
      reference: vendorListState.vendors || {},
      object: vendor.consents || {}
    });
    vendor.legitimateInterests = format({
      reference: vendorListState.vendors || {},
      object: vendor.legitimateInterests || {}
    });
    purpose.consents = format({
      reference: vendorListState.purposes || {},
      object: purpose.consents || {}
    });
    purpose.legitimateInterests = format({
      reference: vendorListState.purposes || {},
      object: purpose.legitimateInterests || {}
    });
    var consentSpecialFeatures = format({
      reference: vendorListState.specialFeatures || {},
      object: specialFeatures
    });
    return {
      vendor: vendor,
      purpose: purpose,
      specialFeatures: consentSpecialFeatures
    };
  };

  var handleSaveExitClick = function handleSaveExitClick() {
    saveUserConsent(formatConsentObject({
      vendor: state.vendors,
      purpose: state.purposes,
      specialFeatures: state.specialFeatures
    }));
    handleCloseModal();
  };

  var changeAllGroup = function changeAllGroup(_ref5) {
    var group = _ref5.group,
        value = _ref5.value;
    setState(function (prevState) {
      var _extends2;

      for (var key in vendorListState[group]) {
        prevState[group].consents[key] = value;
        prevState[group].legitimateInterests[key] = value;
      }

      return _extends({}, prevState, (_extends2 = {}, _extends2[group] = prevState[group], _extends2));
    });
  };

  var handleRejectAll = function handleRejectAll(_ref6) {
    var group = _ref6.group;
    changeAllGroup({
      group: group,
      value: false
    });
  };

  var handleAcceptAll = function handleAcceptAll(_ref7) {
    var group = _ref7.group;
    changeAllGroup({
      group: group,
      value: true
    });
  };

  var handleAcceptAllSpecialFeatures = function handleAcceptAllSpecialFeatures() {
    var specialFeatures = {};
    ADEVINTA_COLLECTED_CONSENTS.specialFeatures.forEach(function (value) {
      return specialFeatures[value] = true;
    });
    setState(_extends({}, state, {
      specialFeatures: specialFeatures
    }));
  };

  var handleRejectAllSpecialFeatures = function handleRejectAllSpecialFeatures() {
    setState(_extends({}, state, {
      specialFeatures: {}
    }));
  };

  var handleConsentsChange = function handleConsentsChange(_ref8) {
    var group = _ref8.group,
        index = _ref8.index,
        value = _ref8.value;
    setState(function (prevState) {
      var _prevState$group = prevState[group],
          consents = _prevState$group.consents,
          legitimateInterests = _prevState$group.legitimateInterests;

      if (consents && legitimateInterests) {
        var _extends3;

        consents[index] = !value;
        legitimateInterests[index] = !value;

        var nextState = _extends({}, prevState, (_extends3 = {}, _extends3[group] = _extends({}, prevState[group], {
          consents: consents,
          legitimateInterests: legitimateInterests
        }), _extends3));

        return nextState;
      } else {
        var _extends4, _extends5;

        var _nextState = _extends({}, prevState, (_extends5 = {}, _extends5[group] = _extends({}, prevState[group], (_extends4 = {}, _extends4[index] = !value, _extends4)), _extends5));

        return _nextState;
      }
    });
  };

  var Logo = /*#__PURE__*/React.memo(function () {
    return /*#__PURE__*/React.createElement("img", {
      className: CLASS + "-logo",
      src: logo,
      alt: "logo"
    });
  });

  var vendorExpandedContent = function vendorExpandedContent(props) {
    return /*#__PURE__*/React.createElement(TcfSecondLayerVendorExpandedContent, Object.assign({}, props, {
      i18n: i18n,
      baseClass: groupBaseClass,
      vendorList: vendorListState
    }));
  };

  var legalExpandedContent = function legalExpandedContent(props) {
    return /*#__PURE__*/React.createElement(TcfSecondLayerLegalExpandedContent, Object.assign({}, props, {
      baseClass: groupBaseClass + "-expanded"
    }));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: CLASS
  }, /*#__PURE__*/React.createElement(SuiModal, {
    isOpen: modalOpen,
    closeOnOutsideClick: true,
    closeOnEscKeyDown: true,
    header: isMobile ? /*#__PURE__*/React.createElement(Logo, null) : false,
    iconClose: isMobile ? /*#__PURE__*/React.createElement(IconClose, null) : false,
    onClose: handleSaveExitClick,
    fitContent: true,
    portalContainerId: "sui-TcfSecondLayerModal"
  }, !isMobile && /*#__PURE__*/React.createElement(Logo, null), /*#__PURE__*/React.createElement("div", {
    className: CLASS + "-main"
  }, /*#__PURE__*/React.createElement("h4", {
    className: CLASS + "-title"
  }, isVendorLayer ? i18n.VENDOR_PAGE.TITLE : i18n.SECOND_LAYER.TITLE), /*#__PURE__*/React.createElement("p", null, isVendorLayer ? i18n.VENDOR_PAGE.TEXT : i18n.SECOND_LAYER.TEXT), !!(vendorListState == null ? void 0 : vendorListState.purposes) && !!(state == null ? void 0 : state.purposes) && !isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.PURPOSES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.purposes,
    state: state.purposes,
    filteredIds: ADEVINTA_COLLECTED_CONSENTS.purposes,
    onConsentChange: function onConsentChange(props) {
      return handleConsentsChange(_extends({
        group: 'purposes'
      }, props));
    },
    hasConsent: true,
    i18n: i18n,
    onAcceptAll: function onAcceptAll() {
      return handleAcceptAll({
        group: 'purposes'
      });
    },
    onRejectAll: function onRejectAll() {
      return handleRejectAll({
        group: 'purposes'
      });
    },
    vendorList: vendorListState,
    expandedContent: legalExpandedContent,
    isVendorLayer: isVendorLayer
  }), !!(vendorListState == null ? void 0 : vendorListState.specialFeatures) && !!(state == null ? void 0 : state.specialFeatures) && !isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.SPECIAL_FEATURES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.specialFeatures,
    state: state.specialFeatures,
    filteredIds: ADEVINTA_COLLECTED_CONSENTS.specialFeatures,
    onConsentChange: function onConsentChange(props) {
      return handleConsentsChange(_extends({
        group: 'specialFeatures'
      }, props));
    },
    hasConsent: true,
    i18n: i18n,
    onAcceptAll: handleAcceptAllSpecialFeatures,
    onRejectAll: handleRejectAllSpecialFeatures,
    vendorList: vendorListState,
    expandedContent: legalExpandedContent,
    isVendorLayer: isVendorLayer
  }), !!(vendorListState == null ? void 0 : vendorListState.specialPurposes) && !isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.SPECIAL_PURPOSES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.specialPurposes,
    hasConsent: false,
    i18n: i18n,
    vendorList: vendorListState,
    expandedContent: legalExpandedContent,
    isVendorLayer: isVendorLayer
  }), !!(vendorListState == null ? void 0 : vendorListState.features) && !isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.FEATURES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.features,
    hasConsent: false,
    i18n: i18n,
    vendorList: vendorListState,
    expandedContent: legalExpandedContent,
    isVendorLayer: isVendorLayer
  }), !!(state == null ? void 0 : state.vendors) && !!(vendorListState == null ? void 0 : vendorListState.vendors) && isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.VENDOR_PAGE.GROUPS.TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.vendors,
    state: state.vendors,
    onConsentChange: function onConsentChange(props) {
      return handleConsentsChange(_extends({
        group: 'vendors'
      }, props));
    },
    hasConsent: true,
    i18n: i18n,
    onAcceptAll: function onAcceptAll() {
      return handleAcceptAll({
        group: 'vendors'
      });
    },
    onRejectAll: function onRejectAll() {
      return handleRejectAll({
        group: 'vendors'
      });
    },
    vendorList: vendorListState,
    expandedContent: vendorExpandedContent,
    isVendorLayer: isVendorLayer
  })), /*#__PURE__*/React.createElement("footer", {
    className: CLASS + "-footer"
  }, !isMobile && !isVendorLayer && /*#__PURE__*/React.createElement("div", {
    className: CLASS + "-footer--link"
  }, /*#__PURE__*/React.createElement(Button, {
    size: "small",
    design: "link",
    onClick: function onClick() {
      onVendorsClick && onVendorsClick();
    }
  }, i18n.SECOND_LAYER.PARTNERS_LINK)), /*#__PURE__*/React.createElement("div", {
    className: CLASS + "-footer--buttons"
  }, /*#__PURE__*/React.createElement(Button, {
    design: "outline",
    size: "small",
    onClick: onGoBack
  }, i18n.GO_BACK_BUTTON), /*#__PURE__*/React.createElement(Button, {
    size: "small",
    onClick: handleSaveExitClick
  }, i18n.ACCEPT_BUTTON)))));
}
TcfSecondLayer.displayName = 'TcfSecondLayer';